#include <pic.h>				// pic specific identifiers
#define _XTAL_FREQ  4000000		// Xtal speed
__CONFIG(0x3D18);				// Config bits

#define LEDPORT PORTB
#define LEDTRIS	TRISB
#define SWTRIS	TRISA
#define SWPORT	PORTA
#define	SW1		RA7				// Pre- defined in pic.h
#define SW2		RA6
#define SW3		RA5
#define SW4		RA4
#define LED1	RA3				// Led's 
#define LED2	RA2
#define LED3	RA1
#define LED4	RA0

void Dly(int speed);			// C requires function
void chkkey(void);				// prototypes

unsigned char TABLE1[14] ={		// 14 components 
		0b10000000,
		0b01000000,
		0b00100000,
		0b00010000,
		0b00001000,
		0b00000100,
		0b00000010,
		0b00000001,
		0b00000010,
		0b00000100,
		0b00001000,
		0b00010000,
		0b00100000,
		0b01000000};

unsigned char TABLE2[14] ={		// 14 components
		0b11000000,
		0b01100000,
		0b00110000,
		0b00011000,
		0b00001100,
		0b00000110,
		0b00000011,
		0b00000011,
		0b00000110,
		0b00001100,
		0b00011000,
		0b00110000,
		0b01100000,
		0b11000000};

unsigned char TABLE3[14] ={		// 14 components
		0b01111111,
		0b10111111,
		0b11011111,
		0b11101111,
		0b11110111,
		0b11111011,
		0b11111101,
		0b11111110,
		0b11111101,
		0b11111011,
		0b11110111,
		0b11101111,
		0b11011111,
		0b10111111};

int speed=250 ;					// initial speed is fast

void main(void)					// program entry
	{
	char index = 0;				// new loop variable
	CMCON = 0x7;				// Comparitors off
	SWTRIS = 0b11110000;		// Switch port as inputs LED's as outpts
	LEDTRIS = 0b00000000;		// Led port as outputs
	LED1 = 0x1;
	while(1)					// Loop forever
		{
		for(index=0;index<14;index++)		// loop through tables
			{
			if(LED1)
				LEDPORT = TABLE1[index];
			if(LED2)
				LEDPORT = TABLE2[index];
			if(LED3)
				LEDPORT = TABLE3[index];
			Dly(speed);
			}
		}
	}

void Dly(int speed)					// required to simulate Nigels tutorial
	{
	while(speed--)
		{
		__delay_ms(1);		// Every 1 ms
		chkkey();			// scan keys
		}		
	}

void chkkey()
	{
		if(!SW1)				// Switch 1 on
			{
			LED3 = 0x0;			// led 3 off
			LED2 = 0x0;			// led 2 off
			LED1 = 0x1;			// led 1 on
			}				
		if(!SW2)				// Switch 2 on
			{
			LED3 = 0x0;			// led 3 off
			LED1 = 0x0;			// led 1 0ff
			LED2 = 0x1;			// led 2 on
			}					
		if(!SW3)				// Switch 3 on
			{
			LED1 = 0x0;			// led 1 off
			LED2 = 0x0;			// led 2 off
			LED3 = 0x1;			// led 3 on
			}
		if(!SW4)				// Switch 4 is pressed
			{
			__delay_ms(50);		// wait for bounce
			if(SW4)				// check still pressed
				LED4 = 0x0;		// turn led off
			else
				{
				if(LED4)				// Is led on
					{
					LED4 = 0;			// turn off
					speed = 250;		// Slow speed
					while(!SW4)
						{				// wait here
						__delay_ms(50);	// While key still pressed					
						}
					}
				else
					{
					LED4 = 1;			// turn on
					speed = 80;			// Quick speed
					while(!SW4)
						{				// wait here
						__delay_ms(50);	// While key still pressed					
						}
					}
				}
			}
	}			// End!!